Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## sim.field.grid
Class DenseGrid2D

    java.lang.Object
      sim.field.grid.AbstractGrid2D
          sim.field.grid.DenseGrid2D

All Implemented Interfaces:
  java.io.Serializable, Grid2D

    public class DenseGrid2D

extends AbstractGrid2D

A wrapper for 2D arrays of Objects.

This object expects that the 2D arrays are rectangular. You are encouraged to access the array directly. The object implements all of the Grid2D interface. See Grid2D for rules on how to properly implement toroidal or hexagonal grids.

The width and height of the object are provided to avoid having to say field[x].length, etc.

We very strongly encourage you to examine SparseGrid2D first to see if it's more appropriate to your task. If you need arbitrary numbers of Objects to be able to occupy the same location in the grid, or if you have very few Objects and a very large grid, or if your space is unbounded, you should probably use SparseGrid2D instead.

See Also:
  Serialized Form

Field Summary
`Bag[][]` | `field`
`static int` | `INITIAL_BAG_SIZE` The size of an initial bag
`static int` | `LARGE_BAG_RATIO` A bag must be larger than its contents by this ratio to be replaced `replaceLargeBags` is true
`static int` | `MIN_BAG_SIZE` No bags smaller than this size will be replaced regardless of the setting of `replaceLargeBags`
`boolean` | `removeEmptyBags` Should we remove bags in the field if they have been emptied, and let them GC, or should we keep them around?
`boolean` | `replaceLargeBags` When a bag drops to one quarter capacity, should we replace it with a new bag?
`static int` | `REPLACEMENT_BAG_RATIO` A bag to be replaced will be shrunk to this ratio if `replaceLargeBags` is true

Fields inherited from class sim.field.grid.AbstractGrid2D
`height, width`

Fields inherited from interface sim.field.grid.Grid2D
`ALL, ANY, ANY_SIZE, BOUNDED, CENTER, TOROIDAL, UNBOUNDED`

Constructor Summary
`DenseGrid2D(int width, int height)`

Method Summary
`void` | `addObjectsToLocation(Bag objs, Int2D location)`
`void` | `addObjectsToLocation(Bag objs, int x, int y)` Adds an object to a given location.
`void` | `addObjectsToLocation(java.util.Collection objs, int x, int y)` Adds an object to a given location.
`void` | `addObjectsToLocation(java.lang.Object[] objs, Int2D location)`
`void` | `addObjectsToLocation(java.lang.Object[] objs, int x, int y)` Adds an object to a given location.
`void` | `addObjectToLocation(java.lang.Object obj, Int2D location)`
`void` | `addObjectToLocation(java.lang.Object obj, int x, int y)` Adds an object to a given location.
`Bag` | `clear()` Sets all the locations in the grid to null, and returns in a Bag all stored objects (including duplicates but not null values).
`Bag` | `getHexagonalNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive.
`Bag` | `getHexagonalNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive.
`Bag` | `getMooreNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist, This region forms a square 2*dist+1 cells across, centered at (X,Y).
`Bag` | `getMooreNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist.
`Bag` | `getNeighborsHamiltonianDistance(int x, int y, int dist, boolean toroidal, Bag result, IntBag xPos, IntBag yPos)` Deprecated.
`Bag` | `getNeighborsHexagonalDistance(int x, int y, int dist, boolean toroidal, Bag result, IntBag xPos, IntBag yPos)` Deprecated.
`Bag` | `getNeighborsMaxDistance(int x, int y, int dist, boolean toroidal, Bag result, IntBag xPos, IntBag yPos)` Deprecated.
`Bag` | `getObjectsAtLocation(Int2D location)` Returns a bag containing all the objects at a given location, or null when there are no objects at the location.
`Bag` | `getObjectsAtLocation(int x, int y)` Returns a bag containing all the objects at a given location, or null when there are no objects at the location.
`Bag` | `getRadialNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)`
`Bag` | `getRadialNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, int measurementRule, boolean closed, Bag result, IntBag xPos, IntBag yPos)`
`Bag` | `getRadialNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)`
`Bag` | `getRadialNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, int measurementRule, boolean closed, Bag result, IntBag xPos, IntBag yPos)`
`Bag` | `getVonNeumannNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist.
`Bag` | `getVonNeumannNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist.
`boolean` | `moveObject(java.lang.Object obj, Int2D from, Int2D to)` If the object is not at FROM, then it's simply inserted into TO, and FALSE is returned.
`boolean` | `moveObject(java.lang.Object obj, int fromX, int fromY, int toX, int toY)` If the object is not at [fromX, fromY], then it's simply inserted into [toX, toY], and FALSE is returned.
`void` | `moveObjects(Int2D from, Int2D to)`
`void` | `moveObjects(int fromX, int fromY, int toX, int toY)`
`int` | `numObjectsAtLocation(Int2D location)`
`int` | `numObjectsAtLocation(int x, int y)`
`boolean` | `removeObjectAtLocation(java.lang.Object obj, Int2D location)`
`boolean` | `removeObjectAtLocation(java.lang.Object obj, int x, int y)`
`boolean` | `removeObjectMultiplyAtLocation(java.lang.Object obj, Int2D location)`
`boolean` | `removeObjectMultiplyAtLocation(java.lang.Object obj, int x, int y)`
`Bag` | `removeObjectsAtLocation(Int2D location)` Removes all the objects stored at the given location and returns them as a Bag (which you are free to modify).
`Bag` | `removeObjectsAtLocation(int x, int y)` Removes all the objects stored at the given location and returns them as a Bag (which you are free to modify).

Methods inherited from class sim.field.grid.AbstractGrid2D
`buildMap, buildMap, dlx, dly, downx, downy, drx, dry, getHeight, getHexagonalLocations, getMooreLocations, getNeighborsHamiltonianDistance, getNeighborsHexagonalDistance, getNeighborsMaxDistance, getRadialLocations, getRadialLocations, getVonNeumannLocations, getWidth, removeOrigin, removeOriginToroidal, stx, sty, trb, trt, tx, ty, ulx, uly, upx, upy, urx, ury`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### removeEmptyBags

    public boolean removeEmptyBags

  Should we remove bags in the field if they have been emptied, and let them GC, or should we keep them around?

### replaceLargeBags

    public boolean replaceLargeBags

  When a bag drops to one quarter capacity, should we replace it with a new bag?

### INITIAL_BAG_SIZE

    public static final int INITIAL_BAG_SIZE

  The size of an initial bag

  See Also:
    Constant Field Values

### MIN_BAG_SIZE

    public static final int MIN_BAG_SIZE

  No bags smaller than this size will be replaced regardless of the setting of `replaceLargeBags`

  See Also:
    Constant Field Values

### LARGE_BAG_RATIO

    public static final int LARGE_BAG_RATIO

  A bag must be larger than its contents by this ratio to be replaced `replaceLargeBags` is true

  See Also:
    Constant Field Values

### REPLACEMENT_BAG_RATIO

    public static final int REPLACEMENT_BAG_RATIO

  A bag to be replaced will be shrunk to this ratio if `replaceLargeBags` is true

  See Also:
    Constant Field Values

### field

    public Bag[][] field

Constructor Detail

### DenseGrid2D

    public DenseGrid2D(int width,
                       int height)

Method Detail

### getObjectsAtLocation

    public Bag getObjectsAtLocation(int x,
                                    int y)

  Returns a bag containing all the objects at a given location, or null when there are no objects at the location. You should NOT MODIFY THIS BAG. This is the actual container bag, and modifying it will almost certainly break the Dense Field object. If you want to modify the bag, make a copy and modify the copy instead, using something along the lines of new Bag(foo.getObjectsAtLocation(location)) . Furthermore, changing values in the Dense Field may result in a different bag being used -- so you should not rely on this bag staying valid.

### getObjectsAtLocation

    public Bag getObjectsAtLocation(Int2D location)

  Returns a bag containing all the objects at a given location, or null when there are no objects at the location. You should NOT MODIFY THIS BAG. This is the actual container bag, and modifying it will almost certainly break the Dense Field object. If you want to modify the bag, make a copy and modify the copy instead, using something along the lines of new Bag(foo.getObjectsAtLocation(location)) . Furthermore, changing values in the Dense Field may result in a different bag being used -- so you should not rely on this bag staying valid.

### removeObjectsAtLocation

    public Bag removeObjectsAtLocation(int x,
                                       int y)

  Removes all the objects stored at the given location and returns them as a Bag (which you are free to modify). The location is set to null (the bag is removed) regardless of the setting of removeEmptyBags.

### removeObjectsAtLocation

    public Bag removeObjectsAtLocation(Int2D location)

  Removes all the objects stored at the given location and returns them as a Bag (which you are free to modify). The location is set to null (the bag is removed) regardless of the setting of removeEmptyBags.

### removeObjectAtLocation

    public boolean removeObjectAtLocation(java.lang.Object obj,
                                          int x,
                                          int y)

### removeObjectAtLocation

    public boolean removeObjectAtLocation(java.lang.Object obj,
                                          Int2D location)

### removeObjectMultiplyAtLocation

    public boolean removeObjectMultiplyAtLocation(java.lang.Object obj,
                                                  int x,
                                                  int y)

### removeObjectMultiplyAtLocation

    public boolean removeObjectMultiplyAtLocation(java.lang.Object obj,
                                                  Int2D location)

### moveObject

    public boolean moveObject(java.lang.Object obj,
                              int fromX,
                              int fromY,
                              int toX,
                              int toY)

  If the object is not at [fromX, fromY], then it's simply inserted into [toX, toY], and FALSE is returned. Else it is removed ONCE from [fromX, fromY] and inserted into [toX, toY] and TRUE is returned. If the object exists multiply at [fromX, fromY], only one instance of the object is moved.

### moveObject

    public boolean moveObject(java.lang.Object obj,
                              Int2D from,
                              Int2D to)

  If the object is not at FROM, then it's simply inserted into TO, and FALSE is returned. Else it is removed ONCE from FROM and inserted into TO and TRUE is returned. If the object exists multiply at FROM, only one instance of the object is moved.

### moveObjects

    public void moveObjects(int fromX,
                            int fromY,
                            int toX,
                            int toY)

### moveObjects

    public void moveObjects(Int2D from,
                            Int2D to)

### numObjectsAtLocation

    public int numObjectsAtLocation(int x,
                                    int y)

### numObjectsAtLocation

    public int numObjectsAtLocation(Int2D location)

### addObjectToLocation

    public void addObjectToLocation(java.lang.Object obj,
                                    int x,
                                    int y)

  Adds an object to a given location.

### addObjectToLocation

    public void addObjectToLocation(java.lang.Object obj,
                                    Int2D location)

### addObjectsToLocation

    public void addObjectsToLocation(Bag objs,
                                     int x,
                                     int y)

  Adds an object to a given location.

### addObjectsToLocation

    public void addObjectsToLocation(Bag objs,
                                     Int2D location)

### addObjectsToLocation

    public void addObjectsToLocation(java.lang.Object[] objs,
                                     int x,
                                     int y)

  Adds an object to a given location.

### addObjectsToLocation

    public void addObjectsToLocation(java.lang.Object[] objs,
                                     Int2D location)

### addObjectsToLocation

    public void addObjectsToLocation(java.util.Collection objs,
                                     int x,
                                     int y)

  Adds an object to a given location.

### clear

    public final Bag clear()

  Sets all the locations in the grid to null, and returns in a Bag all stored objects (including duplicates but not null values). You are free to modify the Bag.

### getNeighborsMaxDistance

    public Bag getNeighborsMaxDistance(int x,
                                       int y,
                                       int dist,
                                       boolean toroidal,
                                       Bag result,
                                       IntBag xPos,
                                       IntBag yPos)

  Deprecated.

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist, This region forms a square 2*dist+1 cells across, centered at (X,Y). If dist==1, this is equivalent to the so-called "Moore Neighborhood" (the eight neighbors surrounding (X,Y)), plus (X,Y) itself. Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first.

  Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsMaxDistance(...) Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may only run in two modes: toroidal or bounded. Unbounded lookup is not permitted, and so this function is deprecated: instead you should use the other version of this function which has more functionality. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  The origin -- that is, the (x,y) point at the center of the neighborhood -- is always included in the results.

  This function is equivalent to: `getNeighborsMaxDistance(x,y,dist,toroidal ? Grid2D.TOROIDAL : Grid2D.BOUNDED, true, result, xPos, yPos);`

### getMooreNeighbors

    public Bag getMooreNeighbors(int x,
                                 int y,
                                 int dist,
                                 int mode,
                                 boolean includeOrigin,
                                 Bag result,
                                 IntBag xPos,
                                 IntBag yPos)

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist, This region forms a square 2*dist+1 cells across, centered at (X,Y). If dist==1, this is equivalent to the so-called "Moore Neighborhood" (the eight neighbors surrounding (X,Y)), plus (X,Y) itself. Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first.

  Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsMaxDistance(...) Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getMooreNeighborsAndLocations

    public Bag getMooreNeighborsAndLocations(int x,
                                             int y,
                                             int dist,
                                             int mode,
                                             boolean includeOrigin,
                                             Bag result,
                                             IntBag xPos,
                                             IntBag yPos)

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist. This region forms a square 2*dist+1 cells across, centered at (X,Y). If dist==1, this is equivalent to the so-called "Moore Neighborhood" (the eight neighbors surrounding (X,Y)), plus (X,Y) itself.

  For each Object which falls within this distance, adds the X position, Y position, and Object into the xPos, yPos, and result Bag, clearing them first. Some positions may not appear and that others may appear multiply if multiple objects share that positions. Compare this function with getNeighborsMaxDistance(...). Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getNeighborsHamiltonianDistance

    public Bag getNeighborsHamiltonianDistance(int x,
                                               int y,
                                               int dist,
                                               boolean toroidal,
                                               Bag result,
                                               IntBag xPos,
                                               IntBag yPos)

  Deprecated.

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist. This region forms a diamond 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y). If dist==1 this is equivalent to the so-called "Von-Neumann Neighborhood" (the four neighbors above, below, left, and right of (X,Y)), plus (X,Y) itself.

  Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first. Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsHamiltonianDistance(...) Returns the result Bag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may only run in two modes: toroidal or bounded. Unbounded lookup is not permitted, and so this function is deprecated: instead you should use the other version of this function which has more functionality. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  The origin -- that is, the (x,y) point at the center of the neighborhood -- is always included in the results.

  This function is equivalent to: `getNeighborsHamiltonianDistance(x,y,dist,toroidal ? Grid2D.TOROIDAL : Grid2D.BOUNDED, true, result, xPos, yPos);`

### getVonNeumannNeighbors

    public Bag getVonNeumannNeighbors(int x,
                                      int y,
                                      int dist,
                                      int mode,
                                      boolean includeOrigin,
                                      Bag result,
                                      IntBag xPos,
                                      IntBag yPos)

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist. This region forms a diamond 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y). If dist==1 this is equivalent to the so-called "Von-Neumann Neighborhood" (the four neighbors above, below, left, and right of (X,Y)), plus (X,Y) itself.

  Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first. Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsHamiltonianDistance(...) Returns the result Bag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getVonNeumannNeighborsAndLocations

    public Bag getVonNeumannNeighborsAndLocations(int x,
                                                  int y,
                                                  int dist,
                                                  int mode,
                                                  boolean includeOrigin,
                                                  Bag result,
                                                  IntBag xPos,
                                                  IntBag yPos)

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist. This region forms a diamond 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y). If dist==1 this is equivalent to the so-called "Von-Neumann Neighborhood" (the four neighbors above, below, left, and right of (X,Y)), plus (X,Y) itself.

  For each Object which falls within this distance, adds the X position, Y position, and Object into the xPos, yPos, and result Bag, clearing them first. Some positions may not appear and that others may appear multiply if multiple objects share that positions. Compare this function with getNeighborsMaxDistance(...). Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getNeighborsHexagonalDistance

    public Bag getNeighborsHexagonalDistance(int x,
                                             int y,
                                             int dist,
                                             boolean toroidal,
                                             Bag result,
                                             IntBag xPos,
                                             IntBag yPos)

  Deprecated.

  Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive. If dist==1, this is equivalent to the six neighbors immediately surrounding (X,Y), plus (X,Y) itself.

  Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first. Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsHamiltonianDistance(...) Returns the result Bag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may only run in two modes: toroidal or bounded. Unbounded lookup is not permitted, and so this function is deprecated: instead you should use the other version of this function which has more functionality. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  The origin -- that is, the (x,y) point at the center of the neighborhood -- is always included in the results.

  This function is equivalent to: `getNeighborsHexagonalDistance(x,y,dist,toroidal ? Grid2D.TOROIDAL : Grid2D.BOUNDED, true, result, xPos, yPos);`

### getHexagonalNeighbors

    public Bag getHexagonalNeighbors(int x,
                                     int y,
                                     int dist,
                                     int mode,
                                     boolean includeOrigin,
                                     Bag result,
                                     IntBag xPos,
                                     IntBag yPos)

  Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive. If dist==1, this is equivalent to the six neighbors immediately surrounding (X,Y), plus (X,Y) itself.

  Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first. Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsHamiltonianDistance(...) Returns the result Bag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getHexagonalNeighborsAndLocations

    public Bag getHexagonalNeighborsAndLocations(int x,
                                                 int y,
                                                 int dist,
                                                 int mode,
                                                 boolean includeOrigin,
                                                 Bag result,
                                                 IntBag xPos,
                                                 IntBag yPos)

  Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive. If dist==1, this is equivalent to the six neighbors immediately surrounding (X,Y), plus (X,Y) itself.

  For each Object which falls within this distance, adds the X position, Y position, and Object into the xPos, yPos, and result Bag, clearing them first. Some positions may not appear and that others may appear multiply if multiple objects share that positions. Compare this function with getNeighborsMaxDistance(...). Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getRadialNeighbors

    public Bag getRadialNeighbors(int x,
                                  int y,
                                  int dist,
                                  int mode,
                                  boolean includeOrigin,
                                  Bag result,
                                  IntBag xPos,
                                  IntBag yPos)

### getRadialNeighborsAndLocations

    public Bag getRadialNeighborsAndLocations(int x,
                                              int y,
                                              int dist,
                                              int mode,
                                              boolean includeOrigin,
                                              Bag result,
                                              IntBag xPos,
                                              IntBag yPos)

### getRadialNeighbors

    public Bag getRadialNeighbors(int x,
                                  int y,
                                  int dist,
                                  int mode,
                                  boolean includeOrigin,
                                  int measurementRule,
                                  boolean closed,
                                  Bag result,
                                  IntBag xPos,
                                  IntBag yPos)

### getRadialNeighborsAndLocations

    public Bag getRadialNeighborsAndLocations(int x,
                                              int y,
                                              int dist,
                                              int mode,
                                              boolean includeOrigin,
                                              int measurementRule,
                                              boolean closed,
                                              Bag result,
                                              IntBag xPos,
                                              IntBag yPos)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD